OtoCmdRecoder {
	classvar <>doc, <>pauseDoc, spaceSize = 64;
	
	*start {
		doc = Document.new("CmdRecoder")
			.background_(Color.new(0.7, 0.7, 0.8));
		doc.onClose = doc.onClose.addFunc({OtoCmdRecoder.stop});
		doc.string = format("// CmdLogBy_ otophiliaCmdRecoder\n// GMTRaw: %\n\n", Date.gmtime.rawSeconds, Date.localtime.rawSeconds);
	}
	
	*stop {
		pauseDoc = doc;
		doc = nil;
	}
	
	*resume {
		doc = pauseDoc;
		pauseDoc= nil;
	}
	
	*add {|cmdLine|
		var temp = "", nowOffset = 0;
		
		if(doc.notNil, {
			if(cmdLine.last == $\n,{cmdLine = cmdLine.drop(-1)});
			
			cmdLine.findAll("//").do({
				|item, i|	
				temp = temp ++ (cmdLine.copyRange(nowOffset, item-1));
				nowOffset = cmdLine.find("\n", false, item);
			}) !? {cmdLine = temp};
			
			nowOffset = nil;
			nowOffset = (cmdLine.findBackwards("\n") ? -1)+1;
						
			doc.string = doc.string ++ format("%%// at:[%]\n", cmdLine,
				String.fill(spaceSize - (cmdLine.size - nowOffset), $  ), Date.gmtime.rawSeconds);
		});
	}
}



+ Interpreter {
	interpretCmdLine {
		OtoCmdRecoder.add(cmdLine);
		^this.compile(cmdLine).value;
	}
	
	interpretPrintCmdLine {
		var res, func;
		OtoCmdRecoder.add(cmdLine);
		"\n".post;
		func = this.compile(cmdLine);
		res = func.value;
		codeDump.value(cmdLine, res, func);
		res.postln;
	}
}